// OAPhoneNumberFormatter:OATextFieldFormatter
//
// COPYRIGHT 1994 BY M. ONYSCHUK AND ASSOCIATES INC.
// ALL RIGHTS RESERVED.

#import "OAPhoneNumberFormatter.h"
#import "OATextFieldCell.h"

@implementation OAPhoneNumberFormatter:OATextFieldFormatter

- filterSubstring:(unsigned char *)inputText
    ofSize:(int)inputSize
    at:(int)position
{
    switch (position) {
    case 0:			// ( 
	if (inputText[0] == '(') {
	    [self setOutput:"("];
	} else if (NXIsDigit(inputText[0])) {
	    [self setOutputFormat:"(%c", inputText[0]];
	} else {
	    [self setOutput:""];
	}
	break;
    case 1:			// N 
	if (NXIsDigit(inputText[0])) {
	    [self setOutputFormat:"%c", inputText[0]];
	} else {
	    [self setOutput:""];
	}
	break;
    case 2:			// N 
	if (NXIsDigit(inputText[0])) {
	    [self setOutputFormat:"%c", inputText[0]];
	} else {
	    [self setOutput:""];
	}
	break;
    case 3:			// N 
	if (NXIsDigit(inputText[0])) {
	    [self setOutputFormat:"%c) ", inputText[0]];
	} else {
	    [self setOutput:""];
	}
	break;
    case 4:			// ) 
	if (inputText[0] == ')') {
	    [self setOutput:") "];
	} else {
	    [self setOutput:""];
	}
	break;
    case 5:			// blank 
	if (inputText[0] == ' ') {
	    [self setOutput:" "];
	} else {
	    [self setOutput:""];
	}
	break;
    case 6:			// N 
	if (NXIsDigit(inputText[0])) {
	    [self setOutputFormat:"%c", inputText[0]];
	} else {
	    [self setOutput:""];
	}
	break;
    case 7:			// N 
	if (NXIsDigit(inputText[0])) {
	    [self setOutputFormat:"%c", inputText[0]];
	} else {
	    [self setOutput:""];
	}
	break;
    case 8:			// N 
	if (NXIsDigit(inputText[0])) {
	    [self setOutputFormat:"%c-", inputText[0]];
	} else {
	    [self setOutput:""];
	}
	break;
    case 9:			// - 
	if (inputText[0] == '-') {
	    [self setOutput:"-"];
	} else {
	    [self setOutput:""];
	}
	break;
    case 10:			// N 
	if (NXIsDigit(inputText[0])) {
	    [self setOutputFormat:"%c", inputText[0]];
	} else {
	    [self setOutput:""];
	}
	break;
    case 11:			// N 
	if (NXIsDigit(inputText[0])) {
	    [self setOutputFormat:"%c", inputText[0]];
	} else {
	    [self setOutput:""];
	}
	break;
    case 12:			// N 
	if (NXIsDigit(inputText[0])) {
	    [self setOutputFormat:"%c", inputText[0]];
	} else {
	    [self setOutput:""];
	}
	break;
    case 13:			// N 
	if (NXIsDigit(inputText[0])) {
	    [self setOutputFormat:"%c", inputText[0]];
	} else {
	    [self setOutput:""];
	}
	break;
    default:			// nothing 
	[self setOutput:""];
	break;
    }

    return self;
}

- setTextFieldCell:aCell
{
    [aCell setMinimumLength:9];
    [aCell setChecksMinimumLength:YES];

    [aCell setMaximumLength:14];
    [aCell setChecksMaximumLength:YES];

    [aCell setCharacterFiltering:ALLOW_NUMBERS];
    [aCell setFilteringExceptions:"()- "];
    
    return self;
}

@end
