// OARecordNumberFormatter:OATextFieldFormatter
//
// COPYRIGHT 1994 BY M. ONYSCHUK AND ASSOCIATES INC.
// ALL RIGHTS RESERVED.
//
// A Formatter for 10 digit numerics consisting of a 2 digit year value,
// a 6 digit sequence value, and a two digit location identifier value.

#import "OARecordNumberFormatter.h"
#import "OATextFieldCell.h"

@implementation OARecordNumberFormatter:OATextFieldFormatter
- (BOOL)formatString:(unsigned char *)inputText
{
    char                y1, y2;		// year 1 and 2 characters 
    char                bs1, bs2;	// location 1 and 2 characters 

    int                 i, len;		// length of string;
    int			seq;		// sequence number value
    
    if (!inputText || (len = strlen(inputText)) == 0) {
	return [super formatString:inputText];
    }
    
    y1 = inputText[0];
    y2 = inputText[1];
    
    bs1 = inputText[len-2];
    bs2 = inputText[len-1];
    
    seq = 0;
    
    for (i = 2; i < len - 2; i++) {
    	seq = (seq * 10) + (int)(inputText[i] - '0');
    }
    
    [self setOutputFormat:"%c%c%06d%c%c", y1, y2, seq, bs1, bs2];

    return NO;
}

- setTextFieldCell:aCell
{
    [aCell setMinimumLength:5];
    [aCell setChecksMinimumLength:YES];

    [aCell setMaximumLength:10];
    [aCell setChecksMaximumLength:YES];

    [aCell setCharacterFiltering:ALLOW_NUMBERS];

    return self;
}

@end
